package weaver.docs.webservices;

import java.util.List;
import weaver.ldap.LdapUtil;
import weaver.file.Prop;
import weaver.general.GCONST;
import java.util.StringTokenizer;
import weaver.docs.docs.CustomFieldManager;
import weaver.workflow.field.BrowserComInfo;
import weaver.workflow.request.ResourceConditionManager;
import java.util.HashMap;
import java.io.ByteArrayOutputStream;
import weaver.file.ImageFileManager;
import weaver.splitepage.operate.SpopForDoc;
import java.io.IOException;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;
import java.io.OutputStream;
import java.io.BufferedOutputStream;
import java.io.FileOutputStream;
import weaver.file.FileManage;
import weaver.file.FileUpload;
import java.io.ByteArrayInputStream;
import org.apache.axis.encoding.Base64;
import weaver.system.SystemComInfo;
import weaver.file.multipart.DefaultFileRenamePolicy;
import weaver.file.ImageInfo;
import weaver.file.AESCoder;
import java.io.BufferedInputStream;
import java.io.InputStream;
import java.util.zip.ZipInputStream;
import java.io.FileInputStream;
import java.io.File;
import java.util.ArrayList;
import weaver.systeminfo.SystemEnv;
import weaver.hrm.resource.ResourceComInfo;
import weaver.crm.Maint.CustomerInfoComInfo;
import weaver.systeminfo.language.LanguageComInfo;
import weaver.hrm.company.DepartmentComInfo;
import weaver.docs.category.SubCategoryComInfo;
import weaver.docs.category.MainCategoryComInfo;
import weaver.share.ShareManager;
import java.io.Writer;
import oracle.sql.CLOB;
import weaver.conn.ConnStatement;
import weaver.docs.DocDetailLog;
import weaver.docs.category.DocTreeDocFieldComInfo;
import weaver.docs.docs.DocCoder;
import weaver.general.TimeUtil;
import weaver.conn.RecordSet;
import weaver.docs.docs.DocImageManager;
import weaver.docs.docs.DocViewer;
import weaver.docs.docs.DocManager;
import weaver.docs.docs.DocComInfo;
import weaver.docs.category.SecCategoryComInfo;
import weaver.hrm.User;
import weaver.general.Util;
import weaver.general.MD5;
import java.util.Iterator;
import java.util.Date;
import java.util.Map;
import weaver.docs.docs.ImageFileIdUpdate;
import weaver.general.BaseBean;

public class DocServiceImpl extends BaseBean implements DocService
{
    private static ImageFileIdUpdate imageFileIdUpdate;
    private static final Map sessionIDMap;
    private static final Map sessionTimeMap;
    
    private static synchronized void putSessionId(final String s, final Object o) {
        for (final String s2 : DocServiceImpl.sessionTimeMap.keySet()) {
            if (((Date)DocServiceImpl.sessionTimeMap.get(s2)).getTime() - new Date().getTime() > 1800000L) {
                DocServiceImpl.sessionTimeMap.remove(s2);
                DocServiceImpl.sessionIDMap.remove(s2);
            }
        }
        DocServiceImpl.sessionIDMap.put(s, o);
        DocServiceImpl.sessionTimeMap.put(s, new Date());
    }
    
    private static synchronized Object gutSessionId(final String s) {
        for (final String s2 : DocServiceImpl.sessionTimeMap.keySet()) {
            if (((Date)DocServiceImpl.sessionTimeMap.get(s2)).getTime() - new Date().getTime() > 1800000L) {
                DocServiceImpl.sessionTimeMap.remove(s2);
                DocServiceImpl.sessionIDMap.remove(s2);
            }
        }
        DocServiceImpl.sessionTimeMap.put(s, new Date());
        return DocServiceImpl.sessionIDMap.get(s);
    }
    
    public String login(final String anObject, final String anObject2, final int n, final String str) throws Exception {
        String md5ofStr = "";
        if (anObject != null && !"".equals(anObject) && anObject2 != null && !"".equals(anObject2) && str != null && !"".equals(str)) {
            final int checkLogin = this.checkLogin(anObject, anObject2, n);
            this.writeLog((Object)("checkLogin: logresult = " + checkLogin));
            if (checkLogin == 1) {
                final int userId = this.getUserId(anObject, n);
                this.writeLog((Object)("login: userid = " + userId));
                final User userById = this.getUserById(userId);
                if (userById != null) {
                    userById.setLoginip(str);
                    md5ofStr = new MD5().getMD5ofStr(Util.getRandom() + "|" + str);
                    putSessionId(md5ofStr, userById);
                }
            }
        }
        return md5ofStr;
    }
    
    public int createDoc(final DocInfo docInfo, final String s) throws Exception {
        return this.createDocByUser(docInfo, (User)gutSessionId(s));
    }
    
    public int createDocByUser(final DocInfo docInfo, final User user) throws Exception {
        if (user != null && docInfo != null) {
            try {
                final SecCategoryComInfo secCategoryComInfo = new SecCategoryComInfo();
                final DocComInfo docComInfo = new DocComInfo();
                final DocManager docManager = new DocManager();
                final DocViewer docViewer = new DocViewer();
                final DocImageManager docImageManager = new DocImageManager();
                final RecordSet set = new RecordSet();
                final int nextDocId = docManager.getNextDocId(set);
                docInfo.setId(nextDocId);
                final DocAttachment[] attachments = docInfo.getAttachments();
                for (int n = 0; attachments != null && n < attachments.length; ++n) {
                    DocAttachment saveAttachment = attachments[n];
                    if (saveAttachment != null && ((saveAttachment.getFilecontent() != null && !"".equals(saveAttachment.getFilecontent())) || (saveAttachment.getFilerealpath() != null && !"".equals(saveAttachment.getFilerealpath())))) {
                        saveAttachment = this.saveAttachment(saveAttachment);
                        if (saveAttachment == null || saveAttachment.getImagefileid() <= 0) {
                            this.writeLog((Object)"Save Attachment Error!");
                            continue;
                        }
                        saveAttachment.setDocid(nextDocId);
                        final int imagefileid = saveAttachment.getImagefileid();
                        final String filename = saveAttachment.getFilename();
                        docImageManager.resetParameter();
                        String s;
                        if ("".equals(docInfo.getDocSubject())) {
                            docInfo.setDocSubject(this.getFileMainName(filename));
                            docImageManager.setImagefilename(filename);
                            s = this.getFileExt(filename);
                        }
                        else {
                            docImageManager.setImagefilename(filename);
                            s = this.getFileExt(filename);
                        }
                        if (s.equalsIgnoreCase("doc")) {
                            docImageManager.setDocfiletype("3");
                        }
                        else if (s.equalsIgnoreCase("xls")) {
                            docImageManager.setDocfiletype("4");
                        }
                        else if (s.equalsIgnoreCase("ppt")) {
                            docImageManager.setDocfiletype("5");
                        }
                        else if (s.equalsIgnoreCase("wps")) {
                            docImageManager.setDocfiletype("6");
                        }
                        else if (s.equalsIgnoreCase("docx")) {
                            docImageManager.setDocfiletype("7");
                        }
                        else if (s.equalsIgnoreCase("xlsx")) {
                            docImageManager.setDocfiletype("8");
                        }
                        else if (s.equalsIgnoreCase("pptx")) {
                            docImageManager.setDocfiletype("9");
                        }
                        else {
                            docImageManager.setDocfiletype("2");
                        }
                        docImageManager.setDocid(nextDocId);
                        docImageManager.setImagefileid(imagefileid);
                        docImageManager.setIsextfile("1");
                        docImageManager.AddDocImageInfo();
                    }
                    attachments[n] = saveAttachment;
                }
                docInfo.setAttachments(attachments);
                final String currentDateString = TimeUtil.getCurrentDateString();
                final String onlyCurrentTimeString = TimeUtil.getOnlyCurrentTimeString();
                docManager.setId(nextDocId);
                docManager.setMaincategory(docInfo.getMaincategory());
                docManager.setSubcategory(docInfo.getSubcategory());
                docManager.setSeccategory(docInfo.getSeccategory());
                docManager.setLanguageid(user.getLanguage());
                docManager.setDoccontent(docInfo.getDoccontent());
                docManager.setDocstatus("1");
                docManager.setDocsubject(docInfo.getDocSubject());
                docManager.setDoccreaterid(user.getUID());
                docManager.setDocCreaterType(user.getLogintype());
                docManager.setUsertype(user.getLogintype());
                docManager.setOwnerid(user.getUID());
                docManager.setOwnerType(user.getLogintype());
                docManager.setDoclastmoduserid(user.getUID());
                docManager.setDocLastModUserType(user.getLogintype());
                docManager.setDoccreatedate(currentDateString);
                docManager.setDoclastmoddate(currentDateString);
                docManager.setDoccreatetime(onlyCurrentTimeString);
                docManager.setDoclastmodtime(onlyCurrentTimeString);
                docManager.setDoclangurage(user.getLanguage());
                docManager.setKeyword(docInfo.getKeyword());
                docManager.setIsapprover("0");
                docManager.setIsreply(docInfo.getIsreply());
                docManager.setReplydocid(docInfo.getReplydocid());
                docManager.setDocdepartmentid(user.getUserDepartment());
                docManager.setDocreplyable("1");
                docManager.setAccessorycount(1);
                if (docInfo.getParentids() == null || docInfo.getParentids().trim().equals("")) {
                    docManager.setParentids("" + nextDocId);
                }
                else {
                    docManager.setParentids(docInfo.getParentids() + "," + nextDocId);
                }
                docManager.setOrderable("" + secCategoryComInfo.getSecOrderable(docInfo.getSeccategory()));
                docManager.setClientAddress(user.getLoginip());
                docManager.setUserid(user.getUID());
                final String docCode = docInfo.getDocCode();
                if (docCode != null && !docCode.trim().equals("")) {
                    docManager.setDocCode(docCode);
                }
                else {
                    docManager.setDocCode(new DocCoder().getDocCoder("" + docInfo.getSeccategory()));
                }
                docManager.setDocEditionId(docManager.getNextEditionId(set));
                docManager.setDocEdition(1);
                docManager.AddDocInfo();
                docManager.AddShareInfo();
                docComInfo.addDocInfoCache("" + nextDocId);
                docViewer.setDocShareByDoc("" + nextDocId);
                set.executeSql(" update docdetail set accessorycount = (select count(distinct id) from DocImageFile where isextfile = '1' and docid = " + nextDocId + " and docfiletype <> '1'   and docfiletype <> '11') where id = " + nextDocId);
                return nextDocId;
            }
            catch (final Exception ex) {
                this.writeLog("Save Document error:", (Object)ex);
                return -1;
            }
        }
        return 0;
    }
    
    public int updateDoc(final DocInfo docInfo, final String s) throws Exception {
        return this.updateDocByUser(docInfo, (User)gutSessionId(s));
    }
    
    public int updateDocByUser(final DocInfo docInfo, final User user) throws Exception {
        if (!this.getRight(docInfo, user, 0)) {
            return docInfo.getId();
        }
        final DocInfo docByUser = this.getDocByUser(docInfo.getId(), user, "");
        if (user != null && docByUser != null && docInfo != null) {
            final SecCategoryComInfo secCategoryComInfo = new SecCategoryComInfo();
            final DocManager docManager = new DocManager();
            final DocComInfo docComInfo = new DocComInfo();
            final RecordSet set = new RecordSet();
            int i = docByUser.getId();
            if (secCategoryComInfo.isEditionOpen(docInfo.getSeccategory()) && docByUser.getDocStatus() != 0 && docByUser.getDocStatus() != 4) {
                i = docManager.getNextDocId(set);
                docInfo.setId(i);
                if (docByUser.getDocEditionId() <= 0) {
                    docInfo.setDocEditionId(docManager.getNextEditionId(set));
                    docInfo.setDocEdition(1);
                    set.executeSql("update DocDetail set docEditionId=" + docInfo.getDocEditionId() + ",docEdition=" + docInfo.getDocEdition() + " where id=" + docByUser.getId());
                    set.executeSql("update docdetail set docstatus = 7,ishistory = 1 where id <> " + docInfo.getId() + " and docedition > 0 and docedition <= " + docInfo.getDocEdition() + " and doceditionid > 0 and doceditionid = " + docInfo.getDocEditionId());
                }
                else if (docByUser.getDocEdition() <= 0) {
                    docInfo.setDocEdition(docComInfo.getEdition(docInfo.getDocEditionId()) + 1);
                    set.executeSql("update DocDetail set docEditionId=" + docInfo.getDocEditionId() + ",docEdition=" + docInfo.getDocEdition() + " where id=" + docByUser.getId());
                    set.executeSql("update docdetail set docstatus = 7,ishistory = 1 where id <> " + docInfo.getId() + " and docedition > 0 and docedition <= " + docInfo.getDocEdition() + " and doceditionid > 0 and doceditionid = " + docInfo.getDocEditionId());
                }
                else if (docByUser.getDocEditionId() > 0 && docByUser.getDocEdition() > 0) {
                    set.executeSql("update docdetail set docstatus = 7,ishistory = 1 where id <> " + docInfo.getId() + " and docedition > 0 and docedition <= " + docInfo.getDocEdition() + " and doceditionid > 0 and doceditionid = " + docInfo.getDocEditionId());
                }
                docManager.setId(docInfo.getId());
                docManager.setDocsubject(docInfo.getDocSubject());
                docManager.setMaincategory(docInfo.getMaincategory());
                docManager.setSubcategory(docInfo.getSubcategory());
                docManager.setSeccategory(docInfo.getSeccategory());
                docManager.setUsertype(user.getLogintype());
                docManager.setClientAddress(user.getLoginip());
                docManager.setDoccreaterid(docInfo.getDoccreaterid());
                docManager.setDocCreaterType(docInfo.getDoccreatertype() + "");
                String str = "";
                for (int j = 0; j < docByUser.getAttachments().length; ++j) {
                    boolean b = false;
                    for (int k = 0; k < docInfo.getAttachments().length; ++k) {
                        if (docInfo.getAttachments()[k].getImagefileid() == docByUser.getAttachments()[j].getImagefileid()) {
                            b = true;
                        }
                    }
                    if (!b) {
                        str = str + "," + docByUser.getAttachments()[j].getImagefileid();
                    }
                }
                if (str.startsWith(",")) {
                    str = str.substring(1);
                }
                if (str.endsWith(",")) {
                    str = str.substring(0, str.length() - 1);
                }
                docManager.addNewDocForEdition(docByUser.getId(), str);
            }
            else {
                for (int l = 0; l < docByUser.getAttachments().length; ++l) {
                    boolean b2 = false;
                    for (int n = 0; n < docInfo.getAttachments().length; ++n) {
                        if (docInfo.getAttachments()[n].getImagefileid() == docByUser.getAttachments()[l].getImagefileid()) {
                            b2 = true;
                        }
                    }
                    if (!b2) {
                        final DocAttachment docAttachment = docByUser.getAttachments()[l];
                        final DocImageManager docImageManager = new DocImageManager();
                        docImageManager.setDocid(docAttachment.getDocid());
                        docImageManager.setImagefileid(docAttachment.getImagefileid());
                        docImageManager.DeleteSingleDocImageInfo();
                    }
                }
            }
            for (int n2 = 0; n2 < docInfo.getAttachments().length; ++n2) {
                boolean b3 = false;
                for (int n3 = 0; n3 < docByUser.getAttachments().length; ++n3) {
                    if (docInfo.getAttachments()[n2].getImagefileid() == docByUser.getAttachments()[n3].getImagefileid()) {
                        b3 = true;
                    }
                }
                if (!b3) {
                    final DocImageManager docImageManager2 = new DocImageManager();
                    DocAttachment saveAttachment = docInfo.getAttachments()[n2];
                    if (saveAttachment != null && ((saveAttachment.getFilecontent() != null && !"".equals(saveAttachment.getFilecontent())) || (saveAttachment.getFilerealpath() != null && !"".equals(saveAttachment.getFilerealpath())))) {
                        saveAttachment = this.saveAttachment(saveAttachment);
                        if (saveAttachment == null || saveAttachment.getImagefileid() <= 0) {
                            this.writeLog((Object)"Save Attachment Error!");
                            continue;
                        }
                        saveAttachment.setDocid(i);
                        final int imagefileid = saveAttachment.getImagefileid();
                        final String filename = saveAttachment.getFilename();
                        docImageManager2.resetParameter();
                        String s;
                        if ("".equals(docInfo.getDocSubject())) {
                            docInfo.setDocSubject(this.getFileMainName(filename));
                            docImageManager2.setImagefilename(filename);
                            s = this.getFileExt(filename);
                        }
                        else {
                            docImageManager2.setImagefilename(filename);
                            s = this.getFileExt(filename);
                        }
                        if (s.equalsIgnoreCase("doc")) {
                            docImageManager2.setDocfiletype("3");
                        }
                        else if (s.equalsIgnoreCase("xls")) {
                            docImageManager2.setDocfiletype("4");
                        }
                        else if (s.equalsIgnoreCase("ppt")) {
                            docImageManager2.setDocfiletype("5");
                        }
                        else if (s.equalsIgnoreCase("wps")) {
                            docImageManager2.setDocfiletype("6");
                        }
                        else if (s.equalsIgnoreCase("docx")) {
                            docImageManager2.setDocfiletype("7");
                        }
                        else if (s.equalsIgnoreCase("xlsx")) {
                            docImageManager2.setDocfiletype("8");
                        }
                        else if (s.equalsIgnoreCase("pptx")) {
                            docImageManager2.setDocfiletype("9");
                        }
                        else {
                            docImageManager2.setDocfiletype("2");
                        }
                        docImageManager2.setDocid(i);
                        docImageManager2.setImagefileid(imagefileid);
                        docImageManager2.setIsextfile("1");
                        docImageManager2.AddDocImageInfo();
                    }
                    docInfo.getAttachments()[n2] = saveAttachment;
                }
            }
            this.updateDocInfo(docInfo, user);
            set.executeSql(" update docdetail set accessorycount = (select count(distinct id) from DocImageFile where isextfile = '1' and docid = " + i + " and docfiletype <> '1'   and docfiletype <> '11') where id = " + i);
            final RecordSet set2 = new RecordSet();
            set2.executeSql("delete DocDummyDetail where docid=" + docInfo.getId());
            if (docInfo.getDummyIds() != null) {
                for (int n4 = 0; n4 < docInfo.getDummyIds().length; ++n4) {
                    final String string = docInfo.getDummyIds()[n4] + "";
                    if (!"".equals(string)) {
                        final String currentDateString = TimeUtil.getCurrentDateString();
                        final String onlyCurrentTimeString = TimeUtil.getOnlyCurrentTimeString();
                        if (!new DocTreeDocFieldComInfo().isHaveSameOne(string, "" + docInfo.getId())) {
                            set2.executeSql("insert into DocDummyDetail(catelogid,docid,importdate,importtime) values (" + string + "," + docInfo.getId() + ",'" + currentDateString + "','" + onlyCurrentTimeString + "')");
                        }
                    }
                }
            }
            return i;
        }
        return 0;
    }
    
    private void updateDocInfo(final DocInfo docInfo, final User user) throws Exception {
        final DocDetailLog docDetailLog = new DocDetailLog();
        final ConnStatement connStatement = new ConnStatement();
        if (connStatement.getDBType().equals("oracle")) {
            final String statementSql = "update DocDetail set maincategory=?,subcategory=?,seccategory=?,doclangurage=?,docapprovable=?,docreplyable=?,isreply=?,replydocid=?,docsubject=?,docpublishtype=?,itemid=?,itemmaincategoryid=?,hrmresid=?,crmid=?,projectid=?,financeid=?,doccreaterid=?,docdepartmentid=?,doccreatedate=?,doccreatetime=?,doclastmoduserid=?,doclastmoddate=?,doclastmodtime=?,docapproveuserid=?,docapprovedate=?,docapprovetime=?,docarchiveuserid=?,docarchivedate=?,docarchivetime=?,docstatus=?,assetid=?,ownerid=?,keyword=?,accessorycount=accessorycount+?,replaydoccount=?,usertype=? ,cancopy=?,canremind=? ,doccode=?,docedition=?,doceditionid=?,ishistory=?,approveType=?,maindoc=?,readoptercanprint=?,docvaliduserid=?,docvaliddate=?,docvalidtime=?,docpubuserid=?,docpubdate=?,docpubtime=?,docreopenuserid=?,docreopendate=?,docreopentime=?,docinvaluserid=?,docinvaldate=?,docinvaltime=?,doccanceluserid=?,doccanceldate=?,doccanceltime=?,selectedpubmouldid=?,invalidationdate=?,docCreaterType=?,docLastModUserType=?,docApproveUserType=?,docValidUserType=?,docInvalUserType=?,docArchiveUserType=?,docCancelUserType=?,docPubUserType=?,docReopenUserType=?,ownerType=?,canPrintedNum=? where id=?";
            try {
                connStatement.setStatementSql(statementSql);
                connStatement.setInt(1, docInfo.getMaincategory());
                connStatement.setInt(2, docInfo.getSubcategory());
                connStatement.setInt(3, docInfo.getSeccategory());
                connStatement.setInt(4, docInfo.getDoclangurage());
                connStatement.setString(5, "");
                connStatement.setString(6, "");
                connStatement.setString(7, docInfo.getIsreply());
                connStatement.setInt(8, docInfo.getReplydocid());
                connStatement.setString(9, docInfo.getDocSubject());
                connStatement.setString(10, (docInfo.getDocPublishType() < 0) ? "" : (docInfo.getDocPublishType() + ""));
                connStatement.setInt(11, docInfo.getItemid());
                connStatement.setInt(12, 0);
                connStatement.setInt(13, docInfo.getHrmresid());
                connStatement.setInt(14, docInfo.getCrmid());
                connStatement.setInt(15, docInfo.getProjectid());
                connStatement.setInt(16, docInfo.getFinanceid());
                connStatement.setInt(17, docInfo.getDoccreaterid());
                connStatement.setInt(18, docInfo.getDocdepartmentid());
                connStatement.setString(19, docInfo.getDoccreatedate());
                connStatement.setString(20, docInfo.getDoccreatetime());
                connStatement.setInt(21, docInfo.getDoclastmoduserid());
                connStatement.setString(22, docInfo.getDoclastmoddate());
                connStatement.setString(23, docInfo.getDoclastmodtime());
                connStatement.setInt(24, docInfo.getDocapproveuserid());
                connStatement.setString(25, docInfo.getDocapprovedate());
                connStatement.setString(26, docInfo.getDocapprovetime());
                connStatement.setInt(27, docInfo.getDocarchiveuserid());
                connStatement.setString(28, docInfo.getDocarchivedate());
                connStatement.setString(29, docInfo.getDocarchivetime());
                connStatement.setString(30, (docInfo.getDocStatus() < 0) ? "" : (docInfo.getDocStatus() + ""));
                connStatement.setInt(31, docInfo.getAssetid());
                connStatement.setInt(32, docInfo.getOwnerid());
                connStatement.setString(33, docInfo.getKeyword());
                connStatement.setInt(34, docInfo.getAccessorycount());
                connStatement.setInt(35, docInfo.getReplaydoccount());
                connStatement.setString(36, (docInfo.getDoccreatertype() < 0) ? "" : (docInfo.getDoccreatertype() + ""));
                connStatement.setString(37, "");
                connStatement.setString(38, "");
                connStatement.setString(39, docInfo.getDocCode());
                connStatement.setInt(40, docInfo.getDocEdition());
                connStatement.setInt(41, docInfo.getDocEditionId());
                connStatement.setInt(42, 0);
                connStatement.setInt(43, 0);
                connStatement.setInt(44, docInfo.getMaindoc());
                connStatement.setInt(45, 0);
                connStatement.setInt(46, 0);
                connStatement.setString(47, "");
                connStatement.setString(48, "");
                connStatement.setInt(49, 0);
                connStatement.setString(50, "");
                connStatement.setString(51, "");
                connStatement.setInt(52, 0);
                connStatement.setString(53, "");
                connStatement.setString(54, "");
                connStatement.setInt(55, docInfo.getDocinvaluserid());
                connStatement.setString(56, docInfo.getDocinvaldate());
                connStatement.setString(57, docInfo.getDocinvaltime());
                connStatement.setInt(58, docInfo.getDoccanceluserid());
                connStatement.setString(59, docInfo.getDoccanceldate());
                connStatement.setString(60, docInfo.getDoccanceltime());
                connStatement.setInt(61, 0);
                connStatement.setString(62, docInfo.getInvalidationdate());
                connStatement.setString(63, (docInfo.getDoccreatertype() < 0) ? "" : (docInfo.getDoccreatertype() + ""));
                connStatement.setString(64, (docInfo.getDoclastmodusertype() < 0) ? "" : (docInfo.getDoclastmodusertype() + ""));
                connStatement.setString(65, (docInfo.getDocapproveusertype() < 0) ? "" : (docInfo.getDocapproveusertype() + ""));
                connStatement.setString(66, "");
                connStatement.setString(67, (docInfo.getDocinvalusertype() < 0) ? "" : (docInfo.getDocinvalusertype() + ""));
                connStatement.setString(68, (docInfo.getDocarchiveusertype() < 0) ? "" : (docInfo.getDocarchiveusertype() + ""));
                connStatement.setString(69, (docInfo.getDoccancelusertype() < 0) ? "" : (docInfo.getDoccancelusertype() + ""));
                connStatement.setString(70, "");
                connStatement.setString(71, "");
                connStatement.setString(72, (docInfo.getOwnertype() < 0) ? "" : (docInfo.getOwnertype() + ""));
                connStatement.setInt(73, 0);
                connStatement.setInt(74, docInfo.getId());
                connStatement.executeUpdate();
                connStatement.setStatementSql("update DocDetailContent set doccontent=empty_clob() where docid=? ");
                connStatement.setInt(1, docInfo.getId());
                connStatement.executeUpdate();
                connStatement.setStatementSql("select doccontent from DocDetailContent where docid = " + docInfo.getId(), false);
                connStatement.executeQuery();
                connStatement.next();
                final CLOB clob = connStatement.getClob(1);
                final char[] charArray = docInfo.getDoccontent().toCharArray();
                final Writer characterOutputStream = clob.getCharacterOutputStream();
                characterOutputStream.write(charArray);
                characterOutputStream.flush();
                characterOutputStream.close();
                docDetailLog.resetParameter();
                docDetailLog.setDocId(docInfo.getId());
                docDetailLog.setDocSubject(docInfo.getDocSubject());
                docDetailLog.setOperateType("2");
                docDetailLog.setOperateUserid(user.getUID());
                docDetailLog.setUsertype(user.getLogintype());
                docDetailLog.setClientAddress(user.getLoginip());
                docDetailLog.setDocCreater(docInfo.getDoccreaterid());
                docDetailLog.setCreatertype(docInfo.getDoccreatertype() + "");
                docDetailLog.setDocLogInfo();
            }
            catch (final Exception ex) {
                this.writeLog((Object)ex);
                throw ex;
            }
            finally {
                try {
                    connStatement.close();
                }
                catch (final Exception ex2) {}
            }
        }
        else {
            final String statementSql2 = "update DocDetail set maincategory=?,subcategory=?,seccategory=?,doclangurage=?,docapprovable=?,docreplyable=?,isreply=?,replydocid=?,docsubject=?,doccontent=?,docpublishtype=?,itemid=?,itemmaincategoryid=?,hrmresid=?,crmid=?,projectid=?,financeid=?,doccreaterid=?,docdepartmentid=?,doccreatedate=?,doccreatetime=?,doclastmoduserid=?,doclastmoddate=?,doclastmodtime=?,docapproveuserid=?,docapprovedate=?,docapprovetime=?,docarchiveuserid=?,docarchivedate=?,docarchivetime=?,docstatus=?,assetid=?,ownerid=?,keyword=?,accessorycount=accessorycount+?,replaydoccount=?,usertype=?,cancopy=?,canremind=?,doccode=?,docedition=?,doceditionid=?,ishistory=?,approveType=?,maindoc=?,readoptercanprint=?,docvaliduserid=?,docvaliddate=?,docvalidtime=?,docpubuserid=?,docpubdate=?,docpubtime=?,docreopenuserid=?,docreopendate=?,docreopentime=?,docinvaluserid=?,docinvaldate=?,docinvaltime=?,doccanceluserid=?,doccanceldate=?,doccanceltime=?,selectedpubmouldid=?,invalidationdate=?,docCreaterType=?,docLastModUserType=?,docApproveUserType=?,docValidUserType=?,docInvalUserType=?,docArchiveUserType=?,docCancelUserType=?,docPubUserType=?,docReopenUserType=?,ownerType=?,canPrintedNum=? where id=?";
            try {
                connStatement.setStatementSql(statementSql2);
                connStatement.setInt(1, docInfo.getMaincategory());
                connStatement.setInt(2, docInfo.getSubcategory());
                connStatement.setInt(3, docInfo.getSeccategory());
                connStatement.setInt(4, docInfo.getDoclangurage());
                connStatement.setString(5, "");
                connStatement.setString(6, "");
                connStatement.setString(7, docInfo.getIsreply());
                connStatement.setInt(8, docInfo.getReplydocid());
                connStatement.setString(9, docInfo.getDocSubject());
                connStatement.setString(10, docInfo.getDoccontent());
                connStatement.setString(11, (docInfo.getDocPublishType() < 0) ? "" : (docInfo.getDocPublishType() + ""));
                connStatement.setInt(12, docInfo.getItemid());
                connStatement.setInt(13, 0);
                connStatement.setInt(14, docInfo.getHrmresid());
                connStatement.setInt(15, docInfo.getCrmid());
                connStatement.setInt(16, docInfo.getProjectid());
                connStatement.setInt(17, docInfo.getFinanceid());
                connStatement.setInt(18, docInfo.getDoccreaterid());
                connStatement.setInt(19, docInfo.getDocdepartmentid());
                connStatement.setString(20, docInfo.getDoccreatedate());
                connStatement.setString(21, docInfo.getDoccreatetime());
                connStatement.setInt(22, docInfo.getDoclastmoduserid());
                connStatement.setString(23, docInfo.getDoclastmoddate());
                connStatement.setString(24, docInfo.getDoclastmodtime());
                connStatement.setInt(25, docInfo.getDocapproveuserid());
                connStatement.setString(26, docInfo.getDocapprovedate());
                connStatement.setString(27, docInfo.getDocapprovetime());
                connStatement.setInt(28, docInfo.getDocarchiveuserid());
                connStatement.setString(29, docInfo.getDocarchivedate());
                connStatement.setString(30, docInfo.getDocarchivetime());
                connStatement.setString(31, (docInfo.getDocStatus() < 0) ? "" : (docInfo.getDocStatus() + ""));
                connStatement.setInt(32, docInfo.getAssetid());
                connStatement.setInt(33, docInfo.getOwnerid());
                connStatement.setString(34, docInfo.getKeyword());
                connStatement.setInt(35, docInfo.getAccessorycount());
                connStatement.setInt(36, docInfo.getReplaydoccount());
                connStatement.setString(37, (docInfo.getDoccreatertype() < 0) ? "" : (docInfo.getDoccreatertype() + ""));
                connStatement.setString(38, "");
                connStatement.setString(39, "");
                connStatement.setString(40, docInfo.getDocCode());
                connStatement.setInt(41, docInfo.getDocEdition());
                connStatement.setInt(42, docInfo.getDocEditionId());
                connStatement.setInt(43, 0);
                connStatement.setInt(44, 0);
                connStatement.setInt(45, docInfo.getMaindoc());
                connStatement.setInt(46, 0);
                connStatement.setInt(47, 0);
                connStatement.setString(48, "");
                connStatement.setString(49, "");
                connStatement.setInt(50, 0);
                connStatement.setString(51, "");
                connStatement.setString(52, "");
                connStatement.setInt(53, 0);
                connStatement.setString(54, "");
                connStatement.setString(55, "");
                connStatement.setInt(56, docInfo.getDocinvaluserid());
                connStatement.setString(57, docInfo.getDocinvaldate());
                connStatement.setString(58, docInfo.getDocinvaltime());
                connStatement.setInt(59, docInfo.getDoccanceluserid());
                connStatement.setString(60, docInfo.getDoccanceldate());
                connStatement.setString(61, docInfo.getDoccanceltime());
                connStatement.setInt(62, 0);
                connStatement.setString(63, docInfo.getInvalidationdate());
                connStatement.setString(64, (docInfo.getDoccreatertype() < 0) ? "" : (docInfo.getDoccreatertype() + ""));
                connStatement.setString(65, (docInfo.getDoclastmodusertype() < 0) ? "" : (docInfo.getDoclastmodusertype() + ""));
                connStatement.setString(66, (docInfo.getDocapproveusertype() < 0) ? "" : (docInfo.getDocapproveusertype() + ""));
                connStatement.setString(67, "");
                connStatement.setString(68, (docInfo.getDocinvalusertype() < 0) ? "" : (docInfo.getDocinvalusertype() + ""));
                connStatement.setString(69, (docInfo.getDocarchiveusertype() < 0) ? "" : (docInfo.getDocarchiveusertype() + ""));
                connStatement.setString(70, (docInfo.getDoccancelusertype() < 0) ? "" : (docInfo.getDoccancelusertype() + ""));
                connStatement.setString(71, "");
                connStatement.setString(72, "");
                connStatement.setString(73, (docInfo.getOwnertype() < 0) ? "" : (docInfo.getOwnertype() + ""));
                connStatement.setInt(74, 0);
                connStatement.setInt(75, docInfo.getId());
                connStatement.executeUpdate();
                docDetailLog.resetParameter();
                docDetailLog.setDocId(docInfo.getId());
                docDetailLog.setDocSubject(docInfo.getDocSubject());
                docDetailLog.setOperateType("2");
                docDetailLog.setOperateUserid(user.getUID());
                docDetailLog.setUsertype(user.getLogintype());
                docDetailLog.setClientAddress(user.getLoginip());
                docDetailLog.setDocCreater(docInfo.getDoccreaterid());
                docDetailLog.setCreatertype((docInfo.getDoccreatertype() < 0) ? "" : (docInfo.getDoccreatertype() + ""));
                docDetailLog.setDocLogInfo();
            }
            catch (final Exception ex3) {
                this.writeLog((Object)ex3);
                throw ex3;
            }
            finally {
                try {
                    connStatement.close();
                }
                catch (final Exception ex4) {}
            }
        }
    }
    
    public int deleteDoc(final int n, final String s) throws Exception {
        return this.deleteDocByUser(n, (User)gutSessionId(s));
    }
    
    public int deleteDocByUser(final int i, final User user) throws Exception {
        final DocInfo docByUser = this.getDocByUser(i, user, "");
        if (user != null && this.getRight(docByUser, user, 3)) {
            try {
                final ShareManager shareManager = new ShareManager();
                final DocComInfo docComInfo = new DocComInfo();
                final RecordSet set = new RecordSet();
                final String string = "delete from DocDetail where id=" + i;
                final String string2 = "delete from DocShare where docid=" + i;
                final String string3 = "delete from " + shareManager.getTableName("doc", "inner") + " where sourceid=" + i;
                final String string4 = "delete from " + shareManager.getTableName("doc", "outer") + " where sourceid=" + i;
                final String string5 = "delete from DocImageFile where docid=" + i;
                final String string6 = "delete from docreadtag where docid=" + i;
                final String string7 = "delete from DocDetailLog where docid=" + i;
                final DocImageManager docImageManager = new DocImageManager();
                docImageManager.setDocid(i);
                docImageManager.DeleteAllDocImageInfo();
                set.executeSql(string);
                set.executeSql(string2);
                set.executeSql(string3);
                set.executeSql(string4);
                set.executeSql(string5);
                set.executeSql(string6);
                set.executeSql(string7);
                docComInfo.deleteDocInfoCache("" + i);
                return 1;
            }
            catch (final Exception ex) {
                this.writeLog((Object)ex.toString());
            }
        }
        return 0;
    }
    
    public DocInfo getDoc(final int n, final String s) throws Exception {
        return this.getDocByUser(n, (User)gutSessionId(s), "");
    }
    
    public DocInfo getDocByUser(final int n, final User user, String str) throws Exception {
        final DocInfo docInfo = new DocInfo();
        docInfo.setId(n);
        if (!this.getRight(docInfo, user, 1)) {
            return null;
        }
        str = Util.null2String(str);
        str = "," + str + ",";
        if (user != null) {
            final RecordSet set = new RecordSet();
            final DocComInfo docComInfo = new DocComInfo();
            final MainCategoryComInfo mainCategoryComInfo = new MainCategoryComInfo();
            final SubCategoryComInfo subCategoryComInfo = new SubCategoryComInfo();
            final SecCategoryComInfo secCategoryComInfo = new SecCategoryComInfo();
            final DepartmentComInfo departmentComInfo = new DepartmentComInfo();
            final LanguageComInfo languageComInfo = new LanguageComInfo();
            final CustomerInfoComInfo customerInfoComInfo = new CustomerInfoComInfo();
            final ResourceComInfo resourceComInfo = new ResourceComInfo();
            String str2;
            if (set.getDBType().equals("oracle")) {
                str2 = " select t1.* , t2.doccontent from DocDetail t1 , DocDetailContent t2 where t1.id = t2.docid and ";
            }
            else {
                str2 = " select * from DocDetail t1 where ";
            }
            set.executeSql(str2 + " t1.id = " + n);
            if (set.next()) {
                docInfo.setDocType(Util.getIntValue(Util.null2String(set.getString("doctype")), 1));
                docInfo.setDocSubject(Util.null2String(set.getString("docsubject")).replaceAll("\n", ""));
                docInfo.setDocCode(Util.null2String(set.getString("docCode")));
                docInfo.setDocPublishType(Util.getIntValue(Util.null2String(set.getString("docpublishtype")), 1));
                String publishable;
                if (docInfo.getDocPublishType() == 2) {
                    publishable = SystemEnv.getHtmlLabelName(227, user.getLanguage());
                }
                else if (docInfo.getDocPublishType() == 3) {
                    publishable = SystemEnv.getHtmlLabelName(229, user.getLanguage());
                }
                else {
                    publishable = SystemEnv.getHtmlLabelName(58, user.getLanguage());
                }
                docInfo.setPublishable(publishable);
                docInfo.setDocEdition(Util.getIntValue(Util.null2String(set.getString("docEdition")), 0));
                docInfo.setDocEditionId(Util.getIntValue(Util.null2String(set.getString("docEditionId"))));
                docInfo.setDocEditionStr(docComInfo.getEditionView(docInfo.getId()));
                docInfo.setDocStatus(Util.getIntValue(Util.null2String(set.getString("docstatus"))));
                docInfo.setDocStatusStr(docComInfo.getStatusView(docInfo.getId(), user));
                docInfo.setMaincategory(set.getInt("maincategory"));
                docInfo.setMaincategoryStr(mainCategoryComInfo.getMainCategoryname(docInfo.getMaincategory() + ""));
                docInfo.setSubcategory(set.getInt("subcategory"));
                docInfo.setSubcategoryStr(subCategoryComInfo.getSubCategoryname(docInfo.getSubcategory() + ""));
                docInfo.setSeccategory(set.getInt("seccategory"));
                docInfo.setSeccategoryStr(secCategoryComInfo.getSecCategoryname(docInfo.getSeccategory() + ""));
                docInfo.setAllParentName(secCategoryComInfo.getAllParentName(docInfo.getSeccategory() + "", true));
                docInfo.setDocdepartmentid(set.getInt("docdepartmentid"));
                docInfo.setDocdepartmentStr(departmentComInfo.getDepartmentname(docInfo.getDocdepartmentid() + ""));
                docInfo.setDoclangurage(set.getInt("doclangurage"));
                docInfo.setDoclangurageStr(languageComInfo.getLanguagename(docInfo.getDoclangurage() + ""));
                docInfo.setKeyword(Util.null2String(set.getString("keyword")));
                docInfo.setDoccreaterid(set.getInt("doccreaterid"));
                docInfo.setDoccreatertype(Util.getIntValue(Util.null2String(set.getString("docCreaterType"))));
                docInfo.setDoccreatername((docInfo.getDoccreatertype() == 1) ? resourceComInfo.getResourcename(docInfo.getDoccreaterid() + "") : customerInfoComInfo.getCustomerInfoname(docInfo.getDoccreaterid() + ""));
                docInfo.setDoccreatedate(Util.null2String(set.getString("doccreatedate")));
                docInfo.setDoccreatetime(Util.null2String(set.getString("doccreatetime")));
                docInfo.setDoclastmoduserid(set.getInt("doclastmoduserid"));
                docInfo.setDoclastmodusertype(Util.getIntValue(Util.null2String(set.getString("docLastModUserType"))));
                docInfo.setDoclastmodusername((docInfo.getDoclastmodusertype() == 1) ? resourceComInfo.getResourcename(docInfo.getDoclastmoduserid() + "") : customerInfoComInfo.getCustomerInfoname(docInfo.getDoclastmoduserid() + ""));
                docInfo.setDoclastmoddate(Util.null2String(set.getString("doclastmoddate")));
                docInfo.setDoclastmodtime(Util.null2String(set.getString("doclastmodtime")));
                docInfo.setDocapproveuserid(set.getInt("docapproveuserid"));
                docInfo.setDocapproveusertype(Util.getIntValue(Util.null2String(set.getString("docApproveUserType"))));
                docInfo.setDocapproveusername((docInfo.getDocapproveusertype() == 1) ? resourceComInfo.getResourcename(docInfo.getDocapproveuserid() + "") : customerInfoComInfo.getCustomerInfoname(docInfo.getDocapproveuserid() + ""));
                docInfo.setDocapprovedate(Util.null2String(set.getString("docapprovedate")));
                docInfo.setDocapprovetime(Util.null2String(set.getString("docapprovetime")));
                docInfo.setDocinvaluserid(set.getInt("docInvalUserId"));
                docInfo.setDocinvalusertype(Util.getIntValue(Util.null2String(set.getString("docInvalUserType"))));
                docInfo.setDocinvalusername((docInfo.getDocinvalusertype() == 1) ? resourceComInfo.getResourcename(docInfo.getDocinvaluserid() + "") : customerInfoComInfo.getCustomerInfoname(docInfo.getDocinvaluserid() + ""));
                docInfo.setDocinvaldate(Util.null2String(set.getString("docInvalDate")));
                docInfo.setDocinvaltime(Util.null2String(set.getString("docInvalTime")));
                docInfo.setDocarchiveuserid(set.getInt("docarchiveuserid"));
                docInfo.setDocarchiveusertype(Util.getIntValue(Util.null2String(set.getString("docArchiveUserType"))));
                docInfo.setDocarchiveusername((docInfo.getDocarchiveusertype() == 1) ? resourceComInfo.getResourcename(docInfo.getDocarchiveuserid() + "") : customerInfoComInfo.getCustomerInfoname(docInfo.getDocarchiveuserid() + ""));
                docInfo.setDocarchivedate(Util.null2String(set.getString("docarchivedate")));
                docInfo.setDocarchivetime(Util.null2String(set.getString("docarchivetime")));
                docInfo.setDoccanceluserid(set.getInt("docCancelUserId"));
                docInfo.setDoccancelusertype(Util.getIntValue(Util.null2String(set.getString("docCancelUserType"))));
                docInfo.setDoccancelusername((docInfo.getDoccancelusertype() == 1) ? resourceComInfo.getResourcename(docInfo.getDoccanceluserid() + "") : customerInfoComInfo.getCustomerInfoname(docInfo.getDoccanceluserid() + ""));
                docInfo.setDoccanceldate(Util.null2String(set.getString("docCancelDate")));
                docInfo.setDoccanceltime(Util.null2String(set.getString("docCancelTime")));
                docInfo.setMaindoc(set.getInt("mainDoc"));
                docInfo.setMaindocname((docInfo.getMaindoc() == docInfo.getId()) ? (SystemEnv.getHtmlLabelName(524, user.getLanguage()) + SystemEnv.getHtmlLabelName(58, user.getLanguage())) : docComInfo.getDocname(docInfo.getMaindoc() + ""));
                if (str.indexOf(",getChildDocInfo,") == -1) {
                    final Map childDocInfo = this.getChildDocInfo(docInfo);
                    docInfo.setChilddoc((int[])childDocInfo.get("childdocids"));
                    docInfo.setChiledocname((String[])childDocInfo.get("chiledocnames"));
                }
                docInfo.setOwnerid(set.getInt("ownerid"));
                docInfo.setOwnertype(Util.getIntValue(Util.null2String(set.getString("ownerType"))));
                docInfo.setOwnername((docInfo.getOwnertype() == 1) ? resourceComInfo.getResourcename(docInfo.getOwnerid() + "") : customerInfoComInfo.getCustomerInfoname(docInfo.getOwnerid() + ""));
                docInfo.setInvalidationdate(Util.null2String(set.getString("invalidationdate")));
                if (str.indexOf(",getDummy,") == -1) {
                    final Map dummy = this.getDummy(docInfo);
                    docInfo.setDummyIds((int[])dummy.get("dummyIds"));
                    docInfo.setDummyNames((String[])dummy.get("dummyNames"));
                }
                docInfo.setDoccustomfields(this.getCustomFieldInfo(docInfo, user));
                docInfo.setHrmresid(set.getInt("hrmresid"));
                docInfo.setAssetid(set.getInt("assetid"));
                docInfo.setCrmid(set.getInt("hrmresid"));
                docInfo.setItemid(set.getInt("itemid"));
                docInfo.setProjectid(set.getInt("projectid"));
                docInfo.setFinanceid(set.getInt("financeid"));
                if (str.indexOf(",getDoccontent,") == -1) {
                    String doccontent = Util.toBaseEncoding(set.getString("doccontent"), user.getLanguage(), "1");
                    if (docInfo.getDocPublishType() == 2) {
                        final int index = doccontent.indexOf("!@#$%^&*");
                        if (index != -1) {
                            doccontent = doccontent.substring(index + 8, doccontent.length());
                        }
                    }
                    docInfo.setDoccontent(doccontent);
                }
                if (str.indexOf(",getExtDocInfo,") == -1 && docInfo.getDocType() == 2) {
                    final Map extDocInfo = this.getExtDocInfo(docInfo);
                    docInfo.setVersionId(Util.getIntValue((String)extDocInfo.get("versionId")));
                    docInfo.setImagefileId(Util.getIntValue((String)extDocInfo.get("imageFileId")));
                }
                docInfo.setIsreply(set.getString("isreply"));
                docInfo.setReplydocid(set.getInt("replydocid"));
                docInfo.setAccessorycount(set.getInt("accessorycount"));
                docInfo.setReplaydoccount(set.getInt("replaydoccount"));
                if (str.indexOf(",getAttachment,") == -1) {
                    docInfo.setAttachments(this.getAttachment(docInfo));
                }
                if (str.indexOf(",getPictures,") == -1) {
                    docInfo.setPictures(this.getPictures(docInfo));
                }
            }
        }
        return docInfo;
    }
    
    public int getDocCount(final String s) throws Exception {
        return this.getDocCountByUser((User)gutSessionId(s));
    }
    
    public int getDocCountByUser(final User user) throws Exception {
        if (user != null) {
            final RecordSet set = new RecordSet();
            final ShareManager shareManager = new ShareManager();
            String str;
            if (set.getDBType().equals("oracle")) {
                str = " from DocDetail t1," + shareManager.getShareDetailTableByUser("doc", user) + " t2,DocDetailContent t3 where t1.id = t2.sourceid and t1.id = t3.docid ";
            }
            else {
                str = " from DocDetail t1," + shareManager.getShareDetailTableByUser("doc", user) + " t2 where t1.id = t2.sourceid ";
            }
            final String string = " select count(*) as c " + (str + " and ((docstatus = 7 and (sharelevel>1 or (t1.doccreaterid=" + user.getUID() + ")) ) or t1.docstatus in ('1','2','5')) " + "  and seccategory!=0 and (ishistory is null or ishistory = 0) ");
            this.writeLog((Object)("getDocCount: sql = " + string));
            set.executeSql(string);
            if (set.next()) {
                return set.getInt("c");
            }
        }
        return 0;
    }
    
    public DocInfo[] getList(final String s, final int n, final int i) throws Exception {
        final User user = (User)gutSessionId(s);
        final ArrayList list = new ArrayList();
        if (user != null) {
            final RecordSet set = new RecordSet();
            final ShareManager shareManager = new ShareManager();
            final DocComInfo docComInfo = new DocComInfo();
            final MainCategoryComInfo mainCategoryComInfo = new MainCategoryComInfo();
            final SubCategoryComInfo subCategoryComInfo = new SubCategoryComInfo();
            final SecCategoryComInfo secCategoryComInfo = new SecCategoryComInfo();
            final DepartmentComInfo departmentComInfo = new DepartmentComInfo();
            final LanguageComInfo languageComInfo = new LanguageComInfo();
            final CustomerInfoComInfo customerInfoComInfo = new CustomerInfoComInfo();
            final ResourceComInfo resourceComInfo = new ResourceComInfo();
            String str;
            if (set.getDBType().equals("oracle")) {
                str = " t1.*,t2.sharelevel,t3.doccontent from DocDetail t1," + shareManager.getShareDetailTableByUser("doc", user) + " t2,DocDetailContent t3 where t1.id = t2.sourceid and t1.id = t3.docid ";
            }
            else {
                str = " t1.*,t2.sharelevel from DocDetail t1," + shareManager.getShareDetailTableByUser("doc", user) + " t2 where t1.id = t2.sourceid ";
            }
            final String string = str + " and ((docstatus = 7 and (sharelevel>1 or (t1.doccreaterid=" + user.getUID() + ")) ) or t1.docstatus in ('1','2','5')) " + "  and seccategory!=0 and (ishistory is null or ishistory = 0) " + " order by doclastmoddate desc,doclastmodtime desc,id desc";
            String s2;
            if (n > 0 && i > 0) {
                if (set.getDBType().equals("oracle")) {
                    s2 = "select * from ( select row_.*, rownum rownum_ from ( " + (" select " + string) + " ) row_ where rownum <= " + (n * i + i) + ") where rownum_ > " + n * i;
                }
                else if (n > 1) {
                    int j = i * n;
                    int n2 = i;
                    final int docCountByUser = this.getDocCountByUser(user);
                    if (j > docCountByUser) {
                        j = docCountByUser;
                        n2 = docCountByUser - i * (n - 1);
                    }
                    s2 = " select top " + n2 + " * from ( select top " + n2 + " * from (  select  top " + j + " " + string + " " + ") tbltemp1 " + "order by doclastmoddate asc,doclastmodtime asc,id asc" + " ) tbltemp2 " + "order by doclastmoddate desc,doclastmodtime desc,id desc";
                }
                else {
                    s2 = " select top " + i + string;
                }
            }
            else {
                s2 = " select " + string;
            }
            set.executeSql(s2);
            while (set.next()) {
                final DocInfo docInfo = new DocInfo();
                docInfo.setId(Util.getIntValue(Util.null2String(set.getString("id"))));
                docInfo.setDocType(Util.getIntValue(Util.null2String(set.getString("doctype")), 1));
                docInfo.setDocSubject(Util.null2String(set.getString("docsubject")).replaceAll("\n", ""));
                docInfo.setDocCode(Util.null2String(set.getString("docCode")));
                docInfo.setDocPublishType(Util.getIntValue(Util.null2String(set.getString("docpublishtype")), 1));
                String publishable;
                if (docInfo.getDocPublishType() == 2) {
                    publishable = SystemEnv.getHtmlLabelName(227, user.getLanguage());
                }
                else if (docInfo.getDocPublishType() == 3) {
                    publishable = SystemEnv.getHtmlLabelName(229, user.getLanguage());
                }
                else {
                    publishable = SystemEnv.getHtmlLabelName(58, user.getLanguage());
                }
                docInfo.setPublishable(publishable);
                docInfo.setDocEdition(Util.getIntValue(Util.null2String(set.getString("docEdition")), 0));
                docInfo.setDocEditionId(Util.getIntValue(Util.null2String(set.getString("docEditionId"))));
                docInfo.setDocEditionStr(docComInfo.getEditionView(docInfo.getId()));
                docInfo.setDocStatus(Util.getIntValue(Util.null2String(set.getString("docstatus"))));
                docInfo.setDocStatusStr(docComInfo.getStatusView(docInfo.getId(), user));
                docInfo.setMaincategory(set.getInt("maincategory"));
                docInfo.setMaincategoryStr(mainCategoryComInfo.getMainCategoryname(docInfo.getMaincategory() + ""));
                docInfo.setSubcategory(set.getInt("subcategory"));
                docInfo.setSubcategoryStr(subCategoryComInfo.getSubCategoryname(docInfo.getSubcategory() + ""));
                docInfo.setSeccategory(set.getInt("seccategory"));
                docInfo.setSeccategoryStr(secCategoryComInfo.getSecCategoryname(docInfo.getSeccategory() + ""));
                docInfo.setDocdepartmentid(set.getInt("docdepartmentid"));
                docInfo.setDocdepartmentStr(departmentComInfo.getDepartmentname(docInfo.getDocdepartmentid() + ""));
                docInfo.setDoclangurage(set.getInt("doclangurage"));
                docInfo.setDoclangurageStr(languageComInfo.getLanguagename(docInfo.getDoclangurage() + ""));
                docInfo.setKeyword(Util.null2String(set.getString("keyword")));
                docInfo.setDoccreaterid(set.getInt("doccreaterid"));
                docInfo.setDoccreatertype(Util.getIntValue(Util.null2String(set.getString("docCreaterType"))));
                docInfo.setDoccreatername((docInfo.getDoccreatertype() == 1) ? resourceComInfo.getResourcename(docInfo.getDoccreaterid() + "") : customerInfoComInfo.getCustomerInfoname(docInfo.getDoccreaterid() + ""));
                docInfo.setDoccreatedate(Util.null2String(set.getString("doccreatedate")));
                docInfo.setDoccreatetime(Util.null2String(set.getString("doccreatetime")));
                docInfo.setDoclastmoduserid(set.getInt("doclastmoduserid"));
                docInfo.setDoclastmodusertype(Util.getIntValue(Util.null2String(set.getString("docLastModUserType"))));
                docInfo.setDoclastmodusername((docInfo.getDoclastmodusertype() == 1) ? resourceComInfo.getResourcename(docInfo.getDoclastmoduserid() + "") : customerInfoComInfo.getCustomerInfoname(docInfo.getDoclastmoduserid() + ""));
                docInfo.setDoclastmoddate(Util.null2String(set.getString("doclastmoddate")));
                docInfo.setDoclastmodtime(Util.null2String(set.getString("doclastmodtime")));
                docInfo.setDocapproveuserid(set.getInt("docapproveuserid"));
                docInfo.setDocapproveusertype(Util.getIntValue(Util.null2String(set.getString("docApproveUserType"))));
                docInfo.setDocapproveusername((docInfo.getDocapproveusertype() == 1) ? resourceComInfo.getResourcename(docInfo.getDocapproveuserid() + "") : customerInfoComInfo.getCustomerInfoname(docInfo.getDocapproveuserid() + ""));
                docInfo.setDocapprovedate(Util.null2String(set.getString("docapprovedate")));
                docInfo.setDocapprovetime(Util.null2String(set.getString("docapprovetime")));
                docInfo.setDocinvaluserid(set.getInt("docInvalUserId"));
                docInfo.setDocinvalusertype(Util.getIntValue(Util.null2String(set.getString("docInvalUserType"))));
                docInfo.setDocinvalusername((docInfo.getDocinvalusertype() == 1) ? resourceComInfo.getResourcename(docInfo.getDocinvaluserid() + "") : customerInfoComInfo.getCustomerInfoname(docInfo.getDocinvaluserid() + ""));
                docInfo.setDocinvaldate(Util.null2String(set.getString("docInvalDate")));
                docInfo.setDocinvaltime(Util.null2String(set.getString("docInvalTime")));
                docInfo.setDocarchiveuserid(set.getInt("docarchiveuserid"));
                docInfo.setDocarchiveusertype(Util.getIntValue(Util.null2String(set.getString("docArchiveUserType"))));
                docInfo.setDocarchiveusername((docInfo.getDocarchiveusertype() == 1) ? resourceComInfo.getResourcename(docInfo.getDocarchiveuserid() + "") : customerInfoComInfo.getCustomerInfoname(docInfo.getDocarchiveuserid() + ""));
                docInfo.setDocarchivedate(Util.null2String(set.getString("docarchivedate")));
                docInfo.setDocarchivetime(Util.null2String(set.getString("docarchivetime")));
                docInfo.setDoccanceluserid(set.getInt("docCancelUserId"));
                docInfo.setDoccancelusertype(Util.getIntValue(Util.null2String(set.getString("docCancelUserType"))));
                docInfo.setDoccancelusername((docInfo.getDoccancelusertype() == 1) ? resourceComInfo.getResourcename(docInfo.getDoccanceluserid() + "") : customerInfoComInfo.getCustomerInfoname(docInfo.getDoccanceluserid() + ""));
                docInfo.setDoccanceldate(Util.null2String(set.getString("docCancelDate")));
                docInfo.setDoccanceltime(Util.null2String(set.getString("docCancelTime")));
                docInfo.setMaindoc(set.getInt("mainDoc"));
                docInfo.setMaindocname((docInfo.getMaindoc() == docInfo.getId()) ? (SystemEnv.getHtmlLabelName(524, user.getLanguage()) + SystemEnv.getHtmlLabelName(58, user.getLanguage())) : docComInfo.getDocname(docInfo.getMaindoc() + ""));
                final Map childDocInfo = this.getChildDocInfo(docInfo);
                docInfo.setChilddoc((int[])childDocInfo.get("childdocids"));
                docInfo.setChiledocname((String[])childDocInfo.get("chiledocnames"));
                docInfo.setOwnerid(set.getInt("ownerid"));
                docInfo.setOwnertype(Util.getIntValue(Util.null2String(set.getString("ownerType"))));
                docInfo.setOwnername((docInfo.getOwnertype() == 1) ? resourceComInfo.getResourcename(docInfo.getOwnerid() + "") : customerInfoComInfo.getCustomerInfoname(docInfo.getOwnerid() + ""));
                docInfo.setInvalidationdate(Util.null2String(set.getString("invalidationdate")));
                final Map dummy = this.getDummy(docInfo);
                docInfo.setDummyIds((int[])dummy.get("dummyIds"));
                docInfo.setDummyNames((String[])dummy.get("dummyNames"));
                docInfo.setHrmresid(set.getInt("hrmresid"));
                docInfo.setAssetid(set.getInt("assetid"));
                docInfo.setCrmid(set.getInt("hrmresid"));
                docInfo.setItemid(set.getInt("itemid"));
                docInfo.setProjectid(set.getInt("projectid"));
                docInfo.setFinanceid(set.getInt("financeid"));
                if (docInfo.getDocType() == 2) {
                    final Map extDocInfo = this.getExtDocInfo(docInfo);
                    docInfo.setVersionId(Util.getIntValue((String)extDocInfo.get("versionId")));
                    docInfo.setImagefileId(Util.getIntValue((String)extDocInfo.get("imageFileId")));
                }
                docInfo.setIsreply(set.getString("isreply"));
                docInfo.setReplydocid(set.getInt("replydocid"));
                docInfo.setAccessorycount(set.getInt("accessorycount"));
                docInfo.setReplaydoccount(set.getInt("replaydoccount"));
                list.add(docInfo);
            }
        }
        final DocInfo[] array = new DocInfo[list.size()];
        for (int k = 0; k < list.size(); ++k) {
            array[k] = (DocInfo)list.get(k);
        }
        return array;
    }
    
    private DocAttachment saveAttachment(DocAttachment writeAttachment) throws Exception {
        writeAttachment = this.writeAttachment(writeAttachment);
        if (writeAttachment == null) {
            return null;
        }
        final int imagefilesize = writeAttachment.getImagefilesize();
        final String filerealpath = writeAttachment.getFilerealpath();
        final String str = "1";
        final String string = writeAttachment.getIszip() + "";
        final String str2 = "0";
        final String filename = writeAttachment.getFilename();
        final String filetype = writeAttachment.getFiletype();
        final int isAesEncrype = writeAttachment.getIsAesEncrype();
        final String aesCode = writeAttachment.getAesCode();
        final RecordSet set = new RecordSet();
        final char separator = Util.getSeparator();
        final int imageFileNewId = DocServiceImpl.imageFileIdUpdate.getImageFileNewId();
        set.executeProc("ImageFile_Insert", "" + imageFileNewId + separator + filename + separator + filetype + separator + str + separator + filerealpath + separator + string + separator + str2 + separator + imagefilesize);
        set.executeSql("update ImageFile set isaesencrypt=" + isAesEncrype + ",aescode='" + aesCode + "' where imagefileid=" + imageFileNewId);
        writeAttachment.setImagefileid(imageFileNewId);
        InputStream decrypt = null;
        try {
            if (filetype.indexOf("image") != -1) {
                final File file = new File(filerealpath);
                if (writeAttachment.getIszip() == 1) {
                    final ZipInputStream in = new ZipInputStream(new FileInputStream(file));
                    if (in.getNextEntry() != null) {
                        decrypt = new BufferedInputStream(in);
                    }
                }
                else {
                    decrypt = new BufferedInputStream(new FileInputStream(file));
                }
                if (isAesEncrype == 1) {
                    decrypt = AESCoder.decrypt(decrypt, aesCode);
                }
                final ImageInfo imageInfo = new ImageInfo();
                imageInfo.setInput(decrypt);
                if (!imageInfo.check()) {
                    writeAttachment.setImagefilewidth(0);
                    writeAttachment.setImagefileheight(0);
                }
                else {
                    writeAttachment.setImagefilewidth(imageInfo.getWidth());
                    writeAttachment.setImagefileheight(imageInfo.getHeight());
                }
            }
            else {
                writeAttachment.setImagefilewidth(0);
                writeAttachment.setImagefileheight(0);
            }
        }
        catch (final Exception ex) {
            writeAttachment.setImagefilewidth(0);
            writeAttachment.setImagefileheight(0);
        }
        return writeAttachment;
    }
    
    private DocAttachment writeAttachment(final DocAttachment docAttachment) throws Exception {
        final DefaultFileRenamePolicy defaultFileRenamePolicy = new DefaultFileRenamePolicy();
        final SystemComInfo systemComInfo = new SystemComInfo();
        OutputStream encrypt = null;
        InputStream inputStream = null;
        try {
            int iszip = 0;
            if (systemComInfo.getNeedzip().equals("1")) {
                iszip = 1;
            }
            docAttachment.setIszip(iszip);
            final String isaesencrypt = systemComInfo.getIsaesencrypt();
            final String randomString = Util.getRandomString(13);
            docAttachment.setIsAesEncrype(Util.getIntValue(isaesencrypt, 0));
            docAttachment.setAesCode(randomString);
            if (docAttachment.getFilecontent() != null && !"".equals(docAttachment.getFilecontent())) {
                inputStream = new BufferedInputStream(new ByteArrayInputStream(Base64.decode(docAttachment.getFilecontent())));
            }
            else {
                final File file = new File(docAttachment.getFilerealpath());
                if (docAttachment.getFilename() == null || "".equals(docAttachment.getFilename())) {
                    docAttachment.setFilename(this.getFileMainName(file.getName()));
                }
                inputStream = new BufferedInputStream(new FileInputStream(file));
            }
            final String createDir = FileUpload.getCreateDir(systemComInfo.getFilesystem());
            if (createDir != null) {
                FileManage.createDir(createDir);
            }
            String s = null;
            String s2 = Util.getRandom();
            if (s2 != null) {
                if (iszip != 0) {
                    s = s2;
                    final int lastIndex = s2.lastIndexOf(".");
                    String substring;
                    if (lastIndex != -1) {
                        substring = s2.substring(0, lastIndex);
                    }
                    else {
                        substring = s2;
                    }
                    s2 = substring + ".zip";
                }
                File rename = new File(new String(createDir.getBytes("ISO8859_1"), "UTF-8"), new String(s2.getBytes("ISO8859_1"), "UTF-8"));
                docAttachment.setFilerealpath(rename.getPath());
                if (defaultFileRenamePolicy != null) {
                    rename = defaultFileRenamePolicy.rename(rename);
                    final String s3 = new String(rename.getName().getBytes("UTF-8"), "ISO8859_1");
                }
                if (iszip != 0) {
                    final ZipOutputStream zipOutputStream = new ZipOutputStream(new BufferedOutputStream(new FileOutputStream(rename)));
                    zipOutputStream.setMethod(8);
                    zipOutputStream.putNextEntry(new ZipEntry(new String(s.getBytes("UTF-8"), "ISO8859_1")));
                    encrypt = zipOutputStream;
                }
                else {
                    encrypt = new BufferedOutputStream(new FileOutputStream(rename));
                }
                if (isaesencrypt.equals("1")) {
                    encrypt = AESCoder.encrypt(encrypt, randomString);
                }
                int imagefilesize = 0;
                final byte[] array = new byte[8192];
                int read;
                while ((read = inputStream.read(array)) != -1) {
                    encrypt.write(array, 0, read);
                    imagefilesize += read;
                }
                encrypt.flush();
                docAttachment.setImagefilesize(imagefilesize);
                return docAttachment;
            }
        }
        catch (final IOException ex) {
            this.writeLog("Write Attachment File Error:", (Object)ex);
        }
        finally {
            if (encrypt != null) {
                encrypt.close();
            }
            if (inputStream != null) {
                inputStream.close();
            }
        }
        return null;
    }
    
    private String getFileMainName(String substring) {
        if (substring == null) {
            return "";
        }
        final int lastIndex = substring.lastIndexOf(".");
        if (lastIndex != -1) {
            substring = substring.substring(0, lastIndex);
        }
        return substring;
    }
    
    private String getFileExt(final String s) {
        if (s == null || s.trim().equals("")) {
            return "";
        }
        final int lastIndex = s.lastIndexOf(".");
        if (lastIndex == -1) {
            return "";
        }
        if (lastIndex + 1 >= s.length()) {
            return "";
        }
        return s.substring(lastIndex + 1);
    }
    
    private boolean getRight(final DocInfo docInfo, final User user, final int n) throws Exception {
        final RecordSet set = new RecordSet();
        boolean b = false;
        final DocManager docManager = new DocManager();
        docManager.resetParameter();
        docManager.setId(docInfo.getId());
        docManager.getDocInfoById();
        final String docstatus = docManager.getDocstatus();
        final int isHistory = docManager.getIsHistory();
        final int seccategory = docManager.getSeccategory();
        final String docpublishtype = docManager.getDocpublishtype();
        if (docpublishtype != null && (docpublishtype.equals("2") || docpublishtype.equals("3"))) {
            String str = " select 1 from DocDetail where id=" + docInfo.getId() + " ";
            String string = "";
            boolean b2 = false;
            set.executeSql("select newsClause from DocFrontPage where publishType='0'");
            while (set.next()) {
                b2 = true;
                String null2String = Util.null2String(set.getString("newsClause"));
                if (null2String.equals("")) {
                    null2String = " 1=1 ";
                }
                if (!null2String.trim().equals("")) {
                    string = string + " or (" + null2String + ")";
                }
            }
            if (!string.equals("")) {
                str = str + " and (" + string.substring(string.indexOf("(")) + ") ";
            }
            if (b2) {
                set.executeSql(str);
                if (set.next()) {
                    b = true;
                }
            }
        }
        if (user == null) {
            return false;
        }
        final ArrayList docOpratePopedom = new SpopForDoc().getDocOpratePopedom("" + docInfo.getId(), user.getLogintype() + "_" + ("" + user.getUID()) + "_" + user.getSeclevel() + "_" + ("" + user.getType()) + "_" + ("" + user.getUserDepartment()) + "_" + ("" + user.getUserSubCompany1()));
        final SecCategoryComInfo secCategoryComInfo = new SecCategoryComInfo();
        boolean b3 = false;
        int n2 = 0;
        boolean b4 = false;
        if (((String)docOpratePopedom.get(0)).equals("true")) {
            b3 = true;
        }
        if (((String)docOpratePopedom.get(1)).equals("true")) {
            n2 = 1;
        }
        if (((String)docOpratePopedom.get(2)).equals("true")) {
            b4 = true;
        }
        boolean b5 = b3 && ((n2 != 0 && !docstatus.equals("8")) || (docstatus.equals("7") && isHistory == 1 && secCategoryComInfo.isReaderCanViewHistoryEdition(seccategory)) || docstatus.equals("1") || docstatus.equals("2") || docstatus.equals("3") || docstatus.equals("9") || docstatus.equals("0") || docstatus.equals("5"));
        if (isHistory == 1) {
            if (secCategoryComInfo.isReaderCanViewHistoryEdition(seccategory)) {
                if (b5 && n2 == 0) {
                    b5 = true;
                }
            }
            else if (b5 && n2 == 0) {
                b5 = false;
            }
        }
        if (n2 != 0 && (docstatus.equals("3") || docstatus.equals("5") || docstatus.equals("6") || isHistory == 1)) {
            n2 = 0;
            b5 = true;
        }
        final boolean b6 = n2 != 0 && (docstatus.equals("0") || docstatus.equals("1") || docstatus.equals("2") || docstatus.equals("7")) && isHistory != 1;
        if (n == 1) {
            return b5;
        }
        if (n == 2) {
            return b;
        }
        if (n == 3) {
            return b4;
        }
        return b6;
    }
    
    private DocAttachment[] getAttachment(final DocInfo docInfo) throws Exception {
        final ArrayList list = new ArrayList();
        final ImageFileManager imageFileManager = new ImageFileManager();
        final DocImageManager docImageManager = new DocImageManager();
        docImageManager.resetParameter();
        docImageManager.setDocid(docInfo.getId());
        docImageManager.selectDocImageInfo2();
        while (docImageManager.next()) {
            final int intValue = Util.getIntValue(docImageManager.getImagefileid());
            if (intValue < 1) {
                continue;
            }
            final DocAttachment docAttachment = new DocAttachment();
            docAttachment.setDocImageFileId(docImageManager.getId());
            docAttachment.setDocid(docInfo.getId());
            docAttachment.setImagefileid(intValue);
            docAttachment.setImagefilename(docImageManager.getImagefilename());
            docAttachment.setImagefiledesc(docImageManager.getImagefiledesc());
            docAttachment.setImagefilewidth(docImageManager.getimagefilewidth());
            docAttachment.setImagefileheight(docImageManager.getImagefileheight());
            docAttachment.setImagefilesize(docImageManager.getImagefielsize());
            docAttachment.setDocfiletype(docImageManager.getDocfiletype());
            docAttachment.setVersionId(docImageManager.getVersionId());
            docAttachment.setVersionDetail(docImageManager.getVersionDetail());
            docAttachment.setIsextfile(docImageManager.getIsextfile());
            final byte[] array = new byte[1024];
            imageFileManager.getImageFileInfoById(intValue);
            final InputStream inputStream = imageFileManager.getInputStream();
            if (inputStream != null) {
                docAttachment.setFilename(imageFileManager.getImageFileName());
                docAttachment.setFiletype(imageFileManager.getImageFileType());
                docAttachment.setFilerealpath(imageFileManager.getFileRealPath());
                docAttachment.setIszip(Util.getIntValue(imageFileManager.getIsZip()));
                docAttachment.setIsencrype(Util.getIntValue(imageFileManager.getIsencrypt()));
                docAttachment.setIsAesEncrype(imageFileManager.getIsaesencrypt());
                docAttachment.setAesCode(imageFileManager.getAescode());
                String encode = "";
                ByteArrayOutputStream byteArrayOutputStream = null;
                try {
                    byteArrayOutputStream = new ByteArrayOutputStream();
                    int read;
                    while ((read = inputStream.read(array)) != -1) {
                        byteArrayOutputStream.write(array, 0, read);
                        byteArrayOutputStream.flush();
                    }
                    encode = Base64.encode(byteArrayOutputStream.toByteArray());
                }
                catch (final Exception ex) {}
                finally {
                    if (inputStream != null) {
                        inputStream.close();
                    }
                    if (byteArrayOutputStream != null) {
                        byteArrayOutputStream.flush();
                    }
                    if (byteArrayOutputStream != null) {
                        byteArrayOutputStream.close();
                    }
                }
                docAttachment.setFilecontent(encode);
            }
            list.add(docAttachment);
        }
        final DocAttachment[] array2 = new DocAttachment[list.size()];
        for (int i = 0; i < list.size(); ++i) {
            array2[i] = (DocAttachment)list.get(i);
        }
        return array2;
    }
    
    private DocAttachment[] getPictures(final DocInfo docInfo) throws Exception {
        final ArrayList list = new ArrayList();
        final DocImageManager docImageManager = new DocImageManager();
        docImageManager.resetParameter();
        docImageManager.setDocid(docInfo.getId());
        docImageManager.selectDocPictures();
        while (docImageManager.next()) {
            final int intValue = Util.getIntValue(docImageManager.getImagefileid());
            if (intValue < 1) {
                continue;
            }
            final DocAttachment docAttachment = new DocAttachment();
            docAttachment.setDocImageFileId(docImageManager.getId());
            docAttachment.setDocid(docInfo.getId());
            docAttachment.setImagefileid(intValue);
            docAttachment.setImagefilename(docImageManager.getImagefilename());
            docAttachment.setImagefiledesc(docImageManager.getImagefiledesc());
            docAttachment.setImagefilewidth(docImageManager.getimagefilewidth());
            docAttachment.setImagefileheight(docImageManager.getImagefileheight());
            docAttachment.setImagefilesize(docImageManager.getImagefielsize());
            docAttachment.setDocfiletype(docImageManager.getDocfiletype());
            docAttachment.setVersionId(docImageManager.getVersionId());
            docAttachment.setVersionDetail(docImageManager.getVersionDetail());
            docAttachment.setIsextfile(docImageManager.getIsextfile());
            final byte[] array = new byte[1024];
            final ConnStatement connStatement = new ConnStatement();
            try {
                final String string = "select imagefilename,filerealpath,iszip,isencrypt,imagefiletype,imagefile,isaesencrypt,aescode from ImageFile where imagefileid = " + intValue;
                final boolean equals = connStatement.getDBType().equals("oracle");
                connStatement.setStatementSql(string);
                connStatement.executeQuery();
                if (connStatement.next()) {
                    final String null2String = Util.null2String(connStatement.getString("isaesencrypt"));
                    final String null2String2 = Util.null2String(connStatement.getString("aescode"));
                    docAttachment.setFilename(Util.null2String(connStatement.getString("imagefilename")));
                    docAttachment.setFiletype(Util.null2String(connStatement.getString("imagefiletype")));
                    docAttachment.setFilerealpath(Util.null2String(connStatement.getString("filerealpath")));
                    docAttachment.setIszip(Util.getIntValue(Util.null2String(connStatement.getString("iszip"))));
                    docAttachment.setIsencrype(Util.getIntValue(Util.null2String(connStatement.getString("isencrypt"))));
                    docAttachment.setIsAesEncrype(Util.getIntValue(null2String, 0));
                    docAttachment.setAesCode(null2String2);
                    final ZipInputStream zipInputStream = null;
                    BufferedInputStream bufferedInputStream;
                    if (docAttachment.getFilerealpath().equals("")) {
                        if (equals) {
                            bufferedInputStream = new BufferedInputStream(connStatement.getBlobBinary("imagefile"));
                        }
                        else {
                            bufferedInputStream = new BufferedInputStream(connStatement.getBinaryStream("imagefile"));
                        }
                    }
                    else {
                        bufferedInputStream = new BufferedInputStream(new FileInputStream(new File(docAttachment.getFilerealpath())));
                    }
                    String encode = "";
                    ByteArrayOutputStream byteArrayOutputStream = null;
                    try {
                        byteArrayOutputStream = new ByteArrayOutputStream();
                        int read;
                        while ((read = bufferedInputStream.read(array)) != -1) {
                            byteArrayOutputStream.write(array, 0, read);
                            byteArrayOutputStream.flush();
                        }
                        encode = Base64.encode(byteArrayOutputStream.toByteArray());
                    }
                    catch (final Exception ex) {}
                    finally {
                        if (bufferedInputStream != null) {
                            bufferedInputStream.close();
                        }
                        if (zipInputStream != null) {
                            zipInputStream.close();
                        }
                        if (byteArrayOutputStream != null) {
                            byteArrayOutputStream.flush();
                        }
                        if (byteArrayOutputStream != null) {
                            byteArrayOutputStream.close();
                        }
                    }
                    docAttachment.setFilecontent(encode);
                }
                list.add(docAttachment);
            }
            catch (final Exception ex2) {}
            finally {
                try {
                    connStatement.close();
                }
                catch (final Exception ex3) {}
            }
        }
        final DocAttachment[] array2 = new DocAttachment[list.size()];
        for (int i = 0; i < list.size(); ++i) {
            array2[i] = (DocAttachment)list.get(i);
        }
        return array2;
    }
    
    private Map getExtDocInfo(final DocInfo docInfo) throws Exception {
        final HashMap hashMap = new HashMap();
        final RecordSet set = new RecordSet();
        set.executeSql("select * from DocImageFile where docid=" + docInfo.getId() + " and (isextfile <> '1' or isextfile is null) order by versionId desc");
        set.next();
        int i = Util.getIntValue(set.getString("versionId"), 0);
        int j = Util.getIntValue(set.getString("imagefileid"));
        if (i == 0) {
            set.executeSql("select * from DocImageFile where docid=" + docInfo.getId() + " order by versionId desc");
            if (set.next()) {
                i = Util.getIntValue(set.getString("versionId"), 0);
                j = Util.getIntValue(set.getString("imagefileid"));
            }
        }
        hashMap.put("versionId", i + "");
        hashMap.put("imageFileId", j + "");
        return hashMap;
    }
    
    private DocCustomField[] getCustomFieldInfo(final DocInfo docInfo, final User user) throws Exception {
        final ResourceConditionManager resourceConditionManager = new ResourceConditionManager();
        final BrowserComInfo browserComInfo = new BrowserComInfo();
        final DepartmentComInfo departmentComInfo = new DepartmentComInfo();
        final RecordSet set = new RecordSet();
        final ArrayList list = new ArrayList();
        final CustomFieldManager customFieldManager = new CustomFieldManager("DocCustomFieldBySecCategory", docInfo.getSeccategory());
        customFieldManager.getCustomFields();
        customFieldManager.getCustomData(docInfo.getId());
        while (customFieldManager.next()) {
            final DocCustomField docCustomField = new DocCustomField();
            docCustomField.setFieldid(customFieldManager.getId());
            docCustomField.setFieldhtmltype(customFieldManager.getHtmlType());
            docCustomField.setFielddbtype(customFieldManager.getFieldDbType());
            docCustomField.setFieldtype(customFieldManager.getType());
            final String stringReplace = Util.StringReplace(Util.StringReplace(customFieldManager.getData("field" + customFieldManager.getId()), "\n", "<br>"), "\r", "");
            docCustomField.setFieldvalue(stringReplace);
            String fieldshow = "";
            if (customFieldManager.getHtmlType().equals("1") || customFieldManager.getHtmlType().equals("2")) {
                fieldshow = stringReplace;
            }
            else if (customFieldManager.getHtmlType().equals("3")) {
                final String value = String.valueOf(customFieldManager.getType());
                String linkurl = browserComInfo.getLinkurl(value);
                String str = "";
                if (value.equals("152") || value.equals("16")) {
                    linkurl = "/workflow/request/ViewRequest.jsp?requestid=";
                }
                if (value.equals("2") || value.equals("19")) {
                    str = stringReplace;
                }
                else if (value.equals("141")) {
                    str = resourceConditionManager.getFormShowName(stringReplace, user.getLanguage());
                }
                else if (value.equals("4")) {
                    str = departmentComInfo.getDepartmentname(stringReplace);
                }
                else if (!stringReplace.equals("")) {
                    final String browsertablename = browserComInfo.getBrowsertablename(value);
                    final String browsercolumname = browserComInfo.getBrowsercolumname(value);
                    final String browserkeycolumname = browserComInfo.getBrowserkeycolumname(value);
                    final HashMap<String, String> hashMap = new HashMap<String, String>();
                    String s;
                    if (value.equals("17") || value.equals("18") || value.equals("27") || value.equals("37") || value.equals("56") || value.equals("57") || value.equals("65") || value.equals("142") || value.equals("152") || value.equals("168")) {
                        s = "select " + browserkeycolumname + "," + browsercolumname + " from " + browsertablename + " where " + browserkeycolumname + " in( " + stringReplace + ")";
                    }
                    else if (value.equals("143")) {
                        int beginIndex;
                        if (stringReplace.startsWith(",")) {
                            beginIndex = 1;
                        }
                        else {
                            beginIndex = 0;
                        }
                        int length;
                        if (stringReplace.endsWith(",")) {
                            length = stringReplace.length() - 1;
                        }
                        else {
                            length = stringReplace.length();
                        }
                        String substring;
                        if (stringReplace.equals(",")) {
                            substring = "0";
                        }
                        else {
                            substring = stringReplace.substring(beginIndex, length);
                        }
                        s = "select " + browserkeycolumname + "," + browsercolumname + " from " + browsertablename + " where " + browserkeycolumname + " in( " + substring + ")";
                    }
                    else {
                        s = "select " + browserkeycolumname + "," + browsercolumname + " from " + browsertablename + " where " + browserkeycolumname + "=" + stringReplace;
                    }
                    set.executeSql(s);
                    while (set.next()) {
                        final String null2String = Util.null2String(set.getString(1));
                        final String screen = Util.toScreen(set.getString(2), user.getLanguage());
                        if (!linkurl.equals("")) {
                            hashMap.put(String.valueOf(null2String), screen);
                        }
                        else {
                            hashMap.put(String.valueOf(null2String), screen);
                        }
                    }
                    final StringTokenizer stringTokenizer = new StringTokenizer(stringReplace, ",");
                    while (stringTokenizer.hasMoreTokens()) {
                        final String nextToken = stringTokenizer.nextToken();
                        if (nextToken.length() > 0 && hashMap.get(nextToken) != null) {
                            str += (Object)hashMap.get(nextToken);
                        }
                    }
                }
                fieldshow = Util.toScreen(str, user.getLanguage());
            }
            else if (customFieldManager.getHtmlType().equals("4")) {
                fieldshow = stringReplace;
            }
            else if (customFieldManager.getHtmlType().equals("5")) {
                customFieldManager.getSelectItem(customFieldManager.getId());
                while (customFieldManager.nextSelect()) {
                    if (customFieldManager.getSelectValue().equals(stringReplace)) {
                        fieldshow = customFieldManager.getSelectName();
                        break;
                    }
                }
            }
            docCustomField.setFieldshow(fieldshow);
            list.add(docCustomField);
        }
        final DocCustomField[] array = new DocCustomField[list.size()];
        for (int i = 0; i < list.size(); ++i) {
            array[i] = (DocCustomField)list.get(i);
        }
        return array;
    }
    
    private Map getDummy(final DocInfo docInfo) throws Exception {
        final HashMap hashMap = new HashMap();
        final DocTreeDocFieldComInfo docTreeDocFieldComInfo = new DocTreeDocFieldComInfo();
        final RecordSet set = new RecordSet();
        set.executeSql("select catelogid from DocDummyDetail where docid=" + docInfo.getId());
        final ArrayList list = new ArrayList();
        final ArrayList list2 = new ArrayList();
        while (set.next()) {
            final int intValue = Util.getIntValue(Util.null2String(set.getString(1)));
            if (intValue > 0) {
                list.add(intValue + "");
                list2.add(Util.null2String(docTreeDocFieldComInfo.getTreeDocFieldName(intValue + "")));
            }
        }
        final int[] array = new int[list.size()];
        for (int i = 0; i < list.size(); ++i) {
            array[i] = Util.getIntValue((String)list.get(i));
        }
        final String[] array2 = new String[list2.size()];
        for (int j = 0; j < list2.size(); ++j) {
            array2[j] = (String)list2.get(j);
        }
        hashMap.put("dummyIds", array);
        hashMap.put("dummyNames", array2);
        return hashMap;
    }
    
    private Map getChildDocInfo(final DocInfo docInfo) throws Exception {
        final ArrayList list = new ArrayList();
        final ArrayList list2 = new ArrayList();
        final RecordSet set = new RecordSet();
        int i;
        String s;
        if (docInfo.getDocEditionId() > -1) {
            set.executeSql(" select id,docSubject from DocDetail where doceditionid = " + docInfo.getDocEditionId() + " and doceditionid > 0  and (isHistory<>'1' or isHistory is null or isHistory='') order by docedition desc ");
            set.next();
            i = Util.getIntValue(set.getString("id"));
            s = Util.null2String(set.getString("docSubject"));
        }
        else {
            i = docInfo.getId();
            s = docInfo.getDocSubject();
        }
        if (i > 0) {
            list.add(i + "");
            list2.add(s);
            set.executeSql(" select id,docSubject from DocDetail where id <> " + i + " and mainDoc = " + i + " and (isHistory<>'1' or isHistory is null or isHistory='') order by id asc ");
            while (set.next()) {
                final int intValue = Util.getIntValue(set.getString("id"));
                final String null2String = Util.null2String(set.getString("docSubject"));
                if (intValue > 0) {
                    list.add(intValue + "");
                    list2.add(null2String);
                }
            }
        }
        final int[] array = new int[list.size()];
        for (int j = 0; j < list.size(); ++j) {
            array[j] = Util.getIntValue((String)list.get(j));
        }
        final String[] array2 = new String[list2.size()];
        for (int k = 0; k < list2.size(); ++k) {
            array2[k] = (String)list2.get(k);
        }
        final HashMap hashMap = new HashMap();
        hashMap.put("childdocids", array);
        hashMap.put("chiledocnames", array2);
        return hashMap;
    }
    
    private int getUserId(final String s) {
        try {
            final String string = "select id from HrmResource where loginid='" + s + "' union select id from HrmResourcemanager where loginid='" + s + "'";
            final RecordSet set = new RecordSet();
            set.executeSql(string);
            if (set.next() && Util.getIntValue(set.getString(1), 0) > 0) {
                return Util.getIntValue(set.getString(1));
            }
        }
        catch (final Exception ex) {
            ex.printStackTrace();
        }
        return 0;
    }
    
    private int getUserId(final String str, final int n) {
        int n2 = 0;
        if (n == 2) {
            try {
                final String string = "select id from HrmResource where loginid='" + str + "' ";
                final RecordSet set = new RecordSet();
                set.executeSql(string);
                if (set.next() && Util.getIntValue(set.getString(1), 0) > 0) {
                    n2 = Util.getIntValue(set.getString(1));
                }
            }
            catch (final Exception ex) {
                ex.printStackTrace();
            }
        }
        else {
            n2 = this.getUserId(str);
        }
        return n2;
    }
    
    private User getUserById(final int uid) {
        final RecordSet set = new RecordSet();
        User user = null;
        set.executeSql("select * from HrmResource where id=" + uid + "");
        if (set.next()) {
            user = new User();
            user.setUid(set.getInt("id"));
            user.setLoginid("loginid");
            user.setFirstname(set.getString("firstname"));
            user.setLastname(set.getString("lastname"));
            user.setAliasname(set.getString("aliasname"));
            user.setTitle(set.getString("title"));
            user.setTitlelocation(set.getString("titlelocation"));
            user.setSex(set.getString("sex"));
            user.setLanguage(Util.getIntValue(set.getString("systemlanguage"), 7));
            user.setTelephone(set.getString("telephone"));
            user.setMobile(set.getString("mobile"));
            user.setMobilecall(set.getString("mobilecall"));
            user.setEmail(set.getString("email"));
            user.setCountryid(set.getString("countryid"));
            user.setLocationid(set.getString("locationid"));
            user.setResourcetype(set.getString("resourcetype"));
            user.setContractdate(set.getString("contractdate"));
            user.setJobtitle(set.getString("jobtitle"));
            user.setJobgroup(set.getString("jobgroup"));
            user.setJobactivity(set.getString("jobactivity"));
            user.setJoblevel(set.getString("joblevel"));
            user.setSeclevel(set.getString("seclevel"));
            user.setUserDepartment(Util.getIntValue(set.getString("departmentid"), 0));
            user.setUserSubCompany1(Util.getIntValue(set.getString("subcompanyid1"), 0));
            user.setUserSubCompany2(Util.getIntValue(set.getString("subcompanyid2"), 0));
            user.setUserSubCompany3(Util.getIntValue(set.getString("subcompanyid3"), 0));
            user.setUserSubCompany4(Util.getIntValue(set.getString("subcompanyid4"), 0));
            user.setManagerid(set.getString("managerid"));
            user.setAssistantid(set.getString("assistantid"));
            user.setPurchaselimit(set.getString("purchaselimit"));
            user.setCurrencyid(set.getString("currencyid"));
            user.setLogintype("1");
            user.setAccount(set.getString("account"));
        }
        set.executeSql(" SELECT id,loginid,firstname,lastname,systemlanguage,seclevel FROM HrmResourceManager WHERE id=" + uid);
        if (set.next()) {
            user = new User();
            user.setUid(uid);
            user.setLoginid(set.getString("loginid"));
            user.setFirstname(set.getString("firstname"));
            user.setLastname(set.getString("lastname"));
            user.setLanguage(Util.getIntValue(set.getString("systemlanguage"), 0));
            user.setSeclevel(set.getString("seclevel"));
            user.setLogintype("1");
        }
        return user;
    }
    
    private int checkLogin(final String anObject, final String s, final int n) {
        if (anObject == null || "".equals(anObject)) {
            return 0;
        }
        if (n == 1) {
            return this.verifyLoginByDyna(anObject, s);
        }
        if (n == 2) {
            return this.verifyLoginByLdap(anObject, s);
        }
        return this.verifyLoginByDb(anObject, s);
    }
    
    private int verifyLoginByDyna(final String anotherString, final String s) {
        try {
            final String string = "select id from HrmResource where loginid='" + anotherString + "' union select id from HrmResourcemanager where loginid='" + anotherString + "'";
            final RecordSet set = new RecordSet();
            set.executeSql(string);
            if (!set.next() || Util.getIntValue(set.getString(1), 0) <= 0) {
                return 4;
            }
            final String string2 = set.getString(1);
            final Class<?> forName = Class.forName("weaver.hrm.resource.UserSecComInfo");
            final Object instance = forName.newInstance();
            final Class[] array = { Class.forName("java.lang.String") };
            final String s2 = (String)forName.getMethod("getUserSecInfoLoginId", (Class[])array).invoke(instance, string2);
            final String s3 = (String)forName.getMethod("getUserSecInfoPassword", (Class[])array).invoke(instance, string2);
            if (s2 == null || !s2.equalsIgnoreCase(anotherString)) {
                return 3;
            }
            if (s3.equals(Util.getEncrypt(s))) {
                return 1;
            }
            return 2;
        }
        catch (final Exception ex) {
            ex.printStackTrace();
            return 5;
        }
    }
    
    private int verifyLoginByLdap(final String s, final String s2) {
        int verifyLoginByDb;
        try {
            final RecordSet set = new RecordSet();
            final String propValue = Prop.getPropValue(GCONST.getConfigFile(), "authentic");
            boolean b = true;
            if (propValue != null && propValue.equals("ldap")) {
                set.executeSql("select * from HrmResourceManager where loginid = '" + s + "'");
                if (set.next()) {
                    b = false;
                }
            }
            String string = "";
            set.executeSql("select isADAccount from HrmResource where loginid='" + s + "'");
            if (set.next()) {
                string = set.getString("isADAccount");
            }
            if (this.ifEqlTarget(propValue, "ldap") && this.ifEqlTarget(string, "1") && b) {
                if (LdapUtil.getInstance().authentic(s, s2)) {
                    verifyLoginByDb = 1;
                }
                else {
                    verifyLoginByDb = 2;
                }
            }
            else {
                verifyLoginByDb = this.verifyLoginByDb(s, s2);
            }
        }
        catch (final Exception ex) {
            ex.printStackTrace();
            verifyLoginByDb = 5;
        }
        this.writeLog((Object)("verifyLoginByLdap: result = " + verifyLoginByDb));
        return verifyLoginByDb;
    }
    
    private int verifyLoginByDb(final String s, final String s2) {
        try {
            final RecordSet set = new RecordSet();
            set.executeSql("select id,password from HrmResource where loginid='" + s + "' union select id,password from HrmResourcemanager where loginid='" + s + "'");
            if (!set.next() || Util.getIntValue(set.getString(1), 0) <= 0) {
                return 3;
            }
            if (Util.null2String(set.getString(2)).equals(Util.getEncrypt(s2))) {
                return 1;
            }
            return 2;
        }
        catch (final Exception ex) {
            ex.printStackTrace();
            return 5;
        }
    }
    
    public String addDocShareByUser(final DocShareInfo[] array, final User user) throws Exception {
        String str = "";
        if (user == null) {
            return "-2";
        }
        if (array.length <= 0) {
            return "-3";
        }
        final ArrayList list = new ArrayList();
        final RecordSet set = new RecordSet();
        final char c = '\u0002';
        final String string = user.getLogintype() + "_" + ("" + user.getUID()) + "_" + user.getSeclevel() + "_" + ("" + user.getType()) + "_" + ("" + user.getUserDepartment()) + "_" + ("" + user.getUserSubCompany1());
        final SpopForDoc spopForDoc = new SpopForDoc();
        final HashMap hashMap = new HashMap();
        for (int i = 0; i < array.length; ++i) {
            final DocShareInfo docShareInfo = array[i];
            final int intValue = Util.getIntValue(docShareInfo.getDocId(), 0);
            if (intValue > 0) {
                List docOpratePopedom;
                if (hashMap.get("" + intValue) != null) {
                    docOpratePopedom = (List)hashMap.get("" + intValue);
                }
                else {
                    docOpratePopedom = spopForDoc.getDocOpratePopedom("" + intValue, string);
                    hashMap.put("" + intValue, docOpratePopedom);
                }
                boolean b = false;
                boolean b2 = false;
                if (((String)docOpratePopedom.get(0)).equals("true")) {
                    b = true;
                }
                if (((String)docOpratePopedom.get(3)).equals("true")) {
                    b2 = true;
                }
                final int intValue2 = Util.getIntValue(docShareInfo.getShareLevel(), 0);
                if (!b2) {
                    if (!b) {
                        continue;
                    }
                    if (intValue2 != 1) {
                        continue;
                    }
                }
                final int intValue3 = Util.getIntValue(docShareInfo.getShareType(), 0);
                final int intValue4 = Util.getIntValue(docShareInfo.getSecLevel(), 0);
                final int intValue5 = Util.getIntValue(docShareInfo.getRoleLevel(), 0);
                final int intValue6 = Util.getIntValue(docShareInfo.getUserId(), 0);
                final int intValue7 = Util.getIntValue(docShareInfo.getSubCompanyId(), 0);
                final int intValue8 = Util.getIntValue(docShareInfo.getDepartmentId(), 0);
                final int intValue9 = Util.getIntValue(docShareInfo.getRoleId(), 0);
                final int intValue10 = Util.getIntValue(docShareInfo.getForAllUser(), 0);
                final int intValue11 = Util.getIntValue(docShareInfo.getCrmId(), 0);
                Util.getIntValue(docShareInfo.getShareSource(), 0);
                Util.null2String(docShareInfo.getIsSecDefaultShare());
                set.executeProc("DocShare_IFromDocSecCat_G", "" + intValue + "" + c + intValue3 + "" + c + intValue4 + "" + c + intValue5 + "" + c + intValue2 + "" + c + intValue6 + "" + c + intValue7 + "" + c + intValue8 + "" + c + intValue9 + "" + c + intValue10 + "" + c + intValue11 + "" + c + Util.getIntValue(docShareInfo.getOrgGroupId(), 0) + "" + c + Util.getIntValue(docShareInfo.getDownloadLevel(), 0));
                if (list.indexOf("" + intValue) == -1) {
                    list.add("" + intValue);
                    if (str.equals("")) {
                        str = "" + intValue;
                    }
                    else {
                        str = str + "," + intValue;
                    }
                }
            }
        }
        final DocViewer docViewer = new DocViewer();
        for (int j = 0; j < list.size(); ++j) {
            docViewer.setDocShareByDoc("" + Util.getIntValue((String)list.get(j), 0));
        }
        return str;
    }
    
    public boolean ifEqlTarget(final String s, final String anObject) {
        return s != null && !s.equals("") && s.equals(anObject);
    }
    
    static {
        DocServiceImpl.imageFileIdUpdate = new ImageFileIdUpdate();
        sessionIDMap = new HashMap();
        sessionTimeMap = new HashMap();
    }
}
